> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/layers-ocgs/extract-layer.md).

# Extract layers from PDF in Xamarin

Learn how to extract PDF layers or OCG (optional content group) from a document with this full sample code. Create, extract, and render PDF layers effortlessly. The Apryse Xamarin SDK streamlines secu

To extract PDF layers or OCG (optional content group) from a document.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc doc = new PDFDoc(filename);
Page page = doc.GetPage(1);

Config init_cfg = doc.GetOCGConfig();
Context ctx = new Context(init_cfg);

PDFDraw pdfdraw = new PDFDraw();
pdfdraw.SetImageSize(1000, 1000);
pdfdraw.SetOCGContext(ctx); // Render the page using the given OCG context.

// Disable drawing of content that is not optional (i.e. is not part of any layer).
ctx.SetNonOCDrawing(false);

// Now render each layer in the input document to a separate image.
Obj ocgs = doc.GetOCGs(); // Get the array of all OCGs in the document.
int i, sz = ocgs.Size();
for (i=0; i<sz; ++i)
{
    Group ocg = new Group(ocgs.GetAt(i));
    ctx.ResetStates(false);
    ctx.SetState(ocg, true);
    string fname = "pdf_layers_" + ocg.GetName() + ".png";
    pdfdraw.Export(page, output_path + fname);
}

// Now draw content that is not part of any layer...
ctx.SetNonOCDrawing(true);
ctx.SetOCDrawMode(Context.OCDrawMode.e_NoOC);
pdfdraw.Export(page, output_path + "pdf_layers_non_oc.png");
```

{% endcode %}
{% endtab %}
{% endtabs %}

[PDF layers (OCG)](/xamarin/get-started/samples.md#pdflayers) Full sample code which demonstrates how to create, extract, render PDF layers.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/xamarin/layers-ocgs/extract-layer.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
